/*---------- REXX: Concat --------------------------------------*/ 
/*                                                              */ 
/*  This process will read a number of files and Concatinate    */ 
/*  them together.  Storing the results in the first file       */ 
/*  identified in the parameter list.                           */ 
/*                                                              */ 
/*--------------------------------------------------------------*/ 

ADDRESS TSO 
ARG args 

PARSE UPPER VAR args File1 args 

IF File1 = '' THEN DO 
   "CLEAR" 
   DO I = 1 to SOURCELINE() 
      IF SUBSTR(SOURCELINE(I), 1, 2) = '/*' THEN 
         SAY STRIP(SOURCELINE(I), 'B') 
      ELSE 
         EXIT 
      END 
   END 

"NEWSTACK" 
IF LISTDSI(File1) = 0 THEN DO 
   "ALLOC DDN(inFile1) SHR DSN("File1") REUSE" 
   "EXECIO * DISKR inFile1 (FINIS)" 
   END 
ELSE 
   "ALLOC DDN(inFile1) NEW LRECL(512) SPACE(10,10) TRACKS DIR(0) DSN("File1") REUSE " 

DO WHILE args <> '' 
   PARSE VAR args NextFile args 
   NextFile = STRIP(NextFile, 'B') 
   IF LISTDSI(NextFile) = 0 THEN DO 
      "ALLOC DDN(inNext) SHR DSN("NextFile") REUSE" 
      "EXECIO * DISKR inNext (FINIS)" 
      "FREE DDN(inNext)" 
      END 
   END 

"EXECIO "QUEUED()" DISKW inFile1 (FINIS)" 
"FREE DDN(inFile1)" 
"DELSTACK" 
EXIT 
